#include <bits/stdc++.h>
using namespace std;

int main() {
	ios::sync_with_stdio(false); cin.tie(0);
	int N, C, Q, rez=0;
	cin>>N>>C>>Q;
	char c[N];
	int L[Q], R[Q];
	cin>>c;
	for(int i=0; i<Q; i++) cin>>L[i]>>R[i];
	for(int i=0; i<Q; i++) {
		for(int j=L[i]-1; j<R[i]; j++) c[j]=(c[j]=='0'?'1':'0');
		if(C==1) {
			for(int l=0; l<N; l++) {
				if(c[l]=='1') {
					int r=l;
					rez+=1;
					while(c[r+1]=='1') r++;
					l=r;
				}
			}
			cout<<rez<<'\n';
		}
	}
	for(int i=0; i<N; i++) cerr<<c[i];
	return 0;
}